<?php
require_once '../lib/config.php';

function action(&$c) {
	if ($_POST['categories']) {
		deleteCategory($c);
	} else if ($_POST['search']) {
		deleteSearch($c);
	} else if ($_POST['all']) {
		deleteCategory($c);
		deleteSearch($c);
		deleteLink($c);
		$c->site->deleteFile(SITE_PATH . 'index');
		$c->site->deleteFile(SITE_PATH . 'copyright');
		@unlink(SITE_PATH . 'sitemap.xml');
		@unlink(SITE_PATH . 'rss.xml');
		deleteInDir(SITE_PATH . 'images');
		$c->config->truncate();
		$c->keyword->truncate();
		$c->link->truncate();
		$c->newpage->truncate();
		$c->plugin->truncate();
		$c->style->truncate();
	}
	$c->set('config', $c->config->read(1));
}


function deleteCategory(&$c) {
	$categories = $c->category2->findAll();
	foreach ($categories as $category2) {
		$pages = $c->page->findAll(array('category2_id' => $category2['id']));
		$c->newpage->deleteAll(array('url' => $category2['id'] . '/'));
		foreach ($pages as $page) {
			$c->newpage->deleteAll(array('url' => $category2['id'] . '/' . $page['id']));
		}
		$c->site->deleteDir(SITE_PATH . $category2['id']);
	}
	$c->page->truncate();
	$c->category2->truncate();
	$c->category->truncate();
}


function deleteSearch(&$c) {
	$keywords = $c->keyword->findList();
	foreach ($keywords as $i => $keyword) {
		$c->newpage->deleteAll(array('url' => 'search/' . ($i + 1)));
	}
	$c->keyword->truncate();
	deleteInDir(SITE_PATH . 'search');
}


function deleteLink(&$c) {
	deleteInDir(SITE_PATH . 'link');
}


function deleteInDir($path) {
	if ($dir = @opendir($path)) {
		while (($file = readdir($dir)) !== false) {
			if (is_file("$path/$file")) {
				@unlink("$path/$file");
			}
		}
	}
}
