<?php
class CAuth extends CObject {
	
	var $controller = null;
	
 
    function setController(&$controller)
    {
		$this->controller = $controller;
    }
	
	
	function isLogin($class = 'user')
	{
		if(!empty($_SESSION[$class]))
		{
			$user = $_SESSION[$class];
			if( !empty( $_COOKIE[$class.'id'] ) )	$this->SetUserCookie( $user, $class );
			return $user;
		}

		if( !empty( $_COOKIE[$class.'id'] ) )
		{
			if( $user = $this->controller->{$class}->findoneby('id', $_COOKIE[$class . 'id']))
			{
				if( $this->hash( $user['email'] ) == $_COOKIE[$class.'email'] &&
					$this->hash( $user['password'] ) == $_COOKIE[$class.'password'] )
				{
					$this->set( $user, $class );
					return $user;
				}
			}
		}

		return false;
	}


	function login( $user, $cookie, $class = 'user' )
	{
		$this->set( $user, $class );
		if( $cookie )
		{
			$this->SetUserCookie( $user, $class );
		}
		return $user;
	}
	
	
	function set( $user, $class = 'user' )
	{
		$_SESSION[$class] = $user;
		if( !empty( $_COOKIE[$class . 'id'] ) )
		{
			$this->SetUserCookie( $user, $class );
		}
	}
	
	
	function update( $user, $class = 'user' )
	{
		if( $this->isLogin( $class ) )
		{
			$this->set( $user, $class );
		}
	}
	
	
	function SetUserCookie( $user, $class )
	{
		$expire		= time()+60*60*24*30;
		setcookie( $class . 'id', $user['id'], $expire, '/' );
		setcookie( $class . "email", $this->hash( $user['email'] ), $expire, "/" );
		setcookie( $class . "password", $this->hash( $user['password'] ), $expire, "/" );
	}
	
	
	function logout( $class = 'user' )
	{
		unset($_SESSION[$class]);
		$expire		= time() - 42000;
		setcookie( $class . 'id', '', $expire, '/' );
		setcookie( $class . "email", '', $expire, '/' );
		setcookie( $class . "password", '', $expire, '/' );
	}
	
	
	function hash( $str )
	{
		return md5('iojewf0990843t0asdf34ff' . $str);
	}	
}
