<?php
require_once dirname(__FILE__) . '/define.php';
require_once dirname(__FILE__) . '/plugin.php';
require_once dirname(__FILE__) . '/style.php';

mb_language('japanese');
define('OLD_INTERNAL_ENCODING', mb_internal_encoding());
mb_internal_encoding('UTF-8');
mb_regex_encoding('UTF-8');
$_POST = convert_request($_POST);
$_GET = convert_request($_GET);

ini_set('include_path', '.:' . dirname(__FILE__) . '/pear');

if (!function_exists('is_secure')) {
	function is_secure(&$c) {
		return true;
	}
}

require_once dirname(__FILE__) . '/cheetan/cheetan.php';



function config_database(&$db) {
//	$db->add('', DB_HOST, DB_USER, DB_PSWD, DB_NAME);
}

function check_secure(&$c) {
	$dir = basename(dirname($_SERVER['SCRIPT_FILENAME']));
	$file = basename($_SERVER['SCRIPT_FILENAME']);
	if ($file != 'login.php') {
		$config = $c->config->read(1);
		$password = $config['password'] ? $config['password'] : ADMIN_PASSWORD;
		if (empty($_COOKIE['admin_password']) || $_COOKIE['admin_password'] != md5($password)) {
			$c->redirect('login.php');
		}
	}
}

/*
function config_models(&$c) {
	$c->db->query('SET NAMES utf8');
	$dir = dirname(__FILE__) . '/models/';
	$c->AddModel($dir . 'user.php');
	$c->AddModel($dir . 'admin.php');
	$c->AddModel($dir . 'access.php');
}
*/

function config_components(&$c) {
	$dir = dirname(__FILE__) . '/components/';
	$c->AddComponent($dir . 'auth.php');
	$c->AddComponent($dir . 'mail.php');
	$c->AddComponent($dir . 'db.php');
	$c->AddComponent($dir . 'site.php');
	$dir = dirname(__FILE__) . '/models/';
	$c->AddComponent($dir . 'config.php');
	$c->AddComponent($dir . 'link.php');
	$c->AddComponent($dir . 'category.php');
	$c->AddComponent($dir . 'category2.php');
	$c->AddComponent($dir . 'keyword.php');
	$c->AddComponent($dir . 'newpage.php');
	$c->AddComponent($dir . 'page.php');
	$c->AddComponent($dir . 'plugin.php');
	$c->AddComponent($dir . 'style.php');
	$c->auth->setController($c);
}

function config_controller(&$c) {
	$c->SetViewPath('templates');
	$dir = basename(dirname($_SERVER['SCRIPT_FILENAME']));
	if ($dir == 'admin') {
		$c->SetTemplateFile('templates/template.html');
	}
}

function flash($msg) {
	$_SESSION['flash'] = $msg;
}

function after_action(&$c) {
	$c->set('session_flash', $_SESSION['flash']);
	unset($_SESSION['flash']);
	if (defined('MOBILE_MODE')) {
		ob_start();
	}
}

function after_render(&$c) {
	if (defined('MOBILE_MODE')) {
		$contents = ob_get_contents();
		ob_end_clean();
		$contents = mb_convert_encoding($contents, 'SJIS', 'UTF-8');
		echo $contents;
	}
}

function convert_request($data) {
	if (is_array($data)) {
		return array_map('convert_request', $data);
	}
	$trans = ini_get('mbstring.encoding_translation');
	if (!$_POST['MAX_FILE_SIZE'] && ($trans == 1 || $trans == 'On')) {
		if (OLD_INTERNAL_ENCODING != 'UTF-8') {
			$data = mb_convert_encoding($data, 'UTF-8', OLD_INTERNAL_ENCODING);
		}
	} else  {
		if (defined('MOBILE_MODE')) {
			$data = mb_convert_encoding($data, 'UTF-8', 'SJIS');
		}
	}
	$data = gpc_stripslashes($data);
	return $data;
}

function myhash($data) {
	return md5($data . 'iojioijewfu2p190231234j');
}

function download($name, $contents) {
    header("Content-Disposition: attachment; filename=\"$name\"");
    header("Content-Length: ".strlen($contents));
    header("Content-Type: application/octet-stream");
	echo $contents;
	exit;
}

function h($data) {
	if (is_array($data)) {
		return array_map('h', $data);
	}
	return htmlspecialchars($data);
}

function pr($data) {
	echo '<pre style="text-align:left;">';
	print_r($data);
	echo '</pre>';
}

function gpc_stripslashes($st) { 
 if (get_magic_quotes_gpc()==1) {  
  return stripslashes($st);  
 } else {  
  return $st;  
 }  
} 
