<?php
class CKeyword extends CDb {
	var $filename = 'keyword.cgi';
	
	function add($keyword) {
		if ($keyword = trim($keyword)) {
			$list = $this->findList();
			if (!in_array($keyword, $list)) {
				if ($fp = fopen($this->getPath(), 'a')) {
					flock($fp, LOCK_EX);
					fputs($fp, $keyword . "\n");
					fclose($fp);
					return count($list) + 1;
				}
			}
		}
		return null;
	}
	
	function findList() {
		$data = file_get_contents($this->getPath());
		$data = trim($data);
		if (!$data) return array();
		return explode("\n", $data);
	}
	
	function findId($keyword) {
		$list = $this->findList();
		$ret = array_search($keyword, $list);
		if ($ret === false) return null;
		return $ret + 1;
	}
}
