<?php
require_once '../../lib/config.php';

function action(&$c) {
	$c->SetTemplateFile(null);
	$style = $c->style->loadData('classic', 'config');
	if (!$style) {
		$class = $c->style->getClass('classic');
		$style = $class->default;
	}
	if ($_POST) {
		$msg = '';
		if ($_FILES['image']['name']) {
			switch( $_FILES['image']['error'] )
			{
			case UPLOAD_ERR_INI_SIZE:
			case UPLOAD_ERR_FORM_SIZE:
				$msg = 'ファイルサイズが大きすぎます。';
				break;
			case UPLOAD_ERR_PARTIAL:
				$msg = 'アップロードに失敗しました。';
				break;
			}
			if (!preg_match('/\.(png|jpe?g|gif)$/i', $_FILES['image']['name'])) {
				$msg = '画像を指定して下さい。';
			}
		}
		if (!$msg) {
			$update = $_POST['style'];
			if ($_FILES['image']['name']) {
				$parts = explode('.', $_FILES['image']['name']);
				$ext = array_pop($parts);
				$filename = "classic_logo.$ext";
				$update['image'] = $filename;
				if ($style['image']) @unlink('../../images/' . $style['image']);
				move_uploaded_file($_FILES['image']['tmp_name'], '../../images/' . $filename);
				chmod('../../images/' . $filename, 0666);
			}
			$update = array_merge($style, $update);
			$c->style->saveData('classic', 'config', $update);
			$c->site->generate();
			$c->redirect($_SERVER['REQUEST_URI']);
		}
		$style = array_merge($style, $_POST['style']);
		$c->set('msg', $msg);
	}
	$c->set('config', $c->config->read(1));
	$c->set('style', $style);
}
