<?php
require_once '../lib/config.php';

function action(&$c) {
	if ($_GET['change']) {
		if ($plugin = $c->plugin->find(array('name' => $_GET['change']))) {
			$data = array('id' => $plugin['id'], 'used' => !$plugin['used']);
			$c->plugin->update($data);
		} else {
			$data = array('name' => $_GET['change'], 'used' => 1);
			$c->plugin->insert($data);
		}
		$c->site->generate();
		$c->redirect('plugin.php');
	}
	$results = $c->plugin->getAllName();
	$plugins = array();
	foreach ($results as $name) {
		$plugin = array(
			'name' => $name,
			'class' => $c->plugin->getClass($name),
			'data' => $c->plugin->findByName($name),
		);
		$plugins[] = $plugin;
	}
	$c->set('plugins', $plugins);
	$c->set('config', $c->config->read(1));
}
