<?php
class Seedls extends Plugin {
	var $name = 'SEED LSプラグイン';
	var $description = 'SEED LSプラグイン';
	var $hits = 30;
	var $blocks = array(
		'links' => array(
			'name' => 'SEEDLS LINK表示',
			'params' => array(
			),
			'html' => '<!--seedls_links--><a href="$seedls_link_url">$seedls_link_name</a><br /><!--/seedls links-->',
		),
	);
	var $xmlData = null;
	var $credit = '<div align="center"><!-- Rakuten Web Services Attribution Snippet FROM HERE -->
<a href="http://webservice.rakuten.co.jp/" target="_blank"><img src="http://webservice.rakuten.co.jp/img/credit/200709/credit_4936.gif" border="0" alt="楽天ウェブサービスセンター" title="楽天ウェブサービスセンター" width="49" height="36"/></a>
<!-- Rakuten Web Services Attribution Snippet TO HERE --></div>';
	var $debug = array();
	
	
	function replaceBlock($type, $block, $params, $blockParams, $html) {
		if (!$html) $html = $this->block['links']['html'];
		$tag = '';
		$links = $this->controller->plugin->loadData('seedls', 'links');
		if ($links) {
			foreach ($links as $link) {
				$from = array('$seedls_link_url', '$seedls_link_name');
				$to = array($link['url'], $link['name']);
				$tag .= str_replace($from, $to, $html);
			}
		}
		return $tag;
	}
	
	
	
	
	function edit($no, $block) {
		switch ($block['block']) {
		case 'search':
		case 'index':
			$this->controller->SetViewFile(dirname(__FILE__) . '/templates/edit_' . $block['block'] . '.html');
			if ($_POST) {
				$params = $_POST['params'];
				return $params;
			} else {
				$params = $block['data'] ? $block['data'] : $this->blocks[$block['block']]['params'];
			}
			$this->controller->set('params', $params);
			break;
		}
		return true;
	}
}
