<?php
function is_secure() {
	return false;
}

require_once 'lib/config.php';

function action(&$c) {
	if (!$_GET['keyword']) $c->redirect('.');
	$keyword = trim($_GET['keyword']);
	$trans = ini_get('mbstring.encoding_translation');
	if ($trans != 1 && $trans != 'On') {
		$keyword = mb_convert_encoding($keyword, 'UTF-8', 'SJIS');
	}
	$config = $c->config->read(1);
	if (!$config['style']) $config['style'] = 'classic';
	if (!$c->style->getClass($config['style'])) {
		echo 'ERROR';
		exit;
	}
	
	if ($id = $c->keyword->add($keyword)) {
		$newpage = array(
			'url' => "search/$id",
			'name' => $keyword,
			'created' => date('Y-m-d H:i:s'),
		);
		$c->newpage->insert($newpage);
		$ret = $c->site->generateSearchPages($id, $keyword);
		$c->site->generateIndex();
		$plugins = $c->plugin->findAllWithClass(array('used' => 1));
		foreach ($plugins as $plugin) {
			if (method_exists($plugin['class'], 'addSearch')) {
				$params = array(
					'id' => $id,
					'keyword' => $keyword,
				);
				$plugin['class']->addSearch($params);
			}
		}
	} else {
		$id = $c->keyword->findId($keyword);
		$ret = $c->site->generateSearchPages($id, $keyword);
	}
	if (!$ret) {
		$msg = $config['search_error'] ? $config['search_error'] : 'サイト内にはご希望の記事はありませんでした。';
		echo $c->site->generateMessage($msg);
		exit;
	}
	if ($id) {
		$config = $c->config->read(1);
		if (!$config['ext']) $config['ext'] = 'html';
		$c->redirect("search/$id." . $config['ext']);
	}
	$c->redirect('.');
}